routes/web.php
<?php

use App\Http\Controllers\FormController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\SubscriptionController;
use App\Http\Controllers\UserController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

Route::get('/', [HomeController::class, 'landing'])->name('landing');
Route::get('/subscription-form/{subscription}', [HomeController::class, 'form'])->name('subscriptionForm');
Route::post('/subscription-form/{subscription}', [HomeController::class, 'submit'])->name('submissionForm');

Auth::routes();

Route::group(['middleware' => 'auth'], function () {
    Route::get('/dashboard', [HomeController::class, 'index'])->name('dashboard');

    Route::middleware('role:admin')->prefix('user')->name('user.')->group(function () {
        Route::get('', [UserController::class, 'index'])->name('index');
        Route::get('/edit/{user}', [UserController::class, 'edit'])->name('edit');
        Route::post('/update/{user}', [UserController::class, 'update'])->name('update');
    });

    Route::middleware('role:admin')->prefix('subscription')->name('subscription.')->group(function () {
        Route::get('', [SubscriptionController::class, 'index'])->name('index');
        Route::get('/create', [SubscriptionController::class, 'create'])->name('create');
        Route::post('/store', [SubscriptionController::class, 'store'])->name('store');
        Route::get('/edit/{subscription}', [SubscriptionController::class, 'edit'])->name('edit');
        Route::put('/update/{subscription}', [SubscriptionController::class, 'update'])->name('update');
    });

    Route::middleware('role:admin')->prefix('form')->name('form.')->group(function () {
        Route::get('', [FormController::class, 'index'])->name('index');
        Route::get('/create', [FormController::class, 'create'])->name('create');
        Route::post('/store', [FormController::class, 'store'])->name('store');
        Route::get('/edit/{form}', [FormController::class, 'edit'])->name('edit');
        Route::put('/update/{form}', [FormController::class, 'update'])->name('update');
        Route::get('/builder/{form}', [FormController::class, 'builder'])->name('builder');
        Route::post('/builder/{form}', [FormController::class, 'storeBuilder'])->name('builder.store');
    });
});

app/Livewire/FormTable.php
<?php

namespace App\Livewire;

use App\Models\Form;
use Livewire\Attributes\Url;
use Livewire\Component;
use Livewire\WithPagination;

class FormTable extends Component
{
    use WithPagination;

    #[Url(history: true)]
    public $perPage = 5;

    #[Url(history: true)]
    public $search = "";

    #[Url(history: true)]
    public $sortBy = "created_at";

    #[Url(history: true)]
    public $sortDir = "desc";

    protected $listeners = ['deleteForm', 'deleteFormBuilder'];

    public function updatedSearch()
    {
        $this->resetPage();
    }

    public function setSortBy($sortByField)
    {
        if ($this->sortBy == $sortByField) {
            $this->sortDir = ($this->sortDir == "asc") ? "desc" : "asc";
            return;
        }
        $this->sortBy = $sortByField;
        $this->sortDir = "desc";
    }

    public function render()
    {
        $forms = Form::search($this->search)->orderBy($this->sortBy, $this->sortDir)->paginate($this->perPage);

        return view('livewire.form-table', [
            'forms' => $forms,
            'totalResults' => $forms->total(),
            'firstResult' => $forms->firstItem(),
            'lastResult' => $forms->lastItem()
        ]);
    }

    public function confirmDeleteForm($id)
    {
        $this->dispatch('swal:confirm', type: 'question', text: 'Are you sure you want to delete this form ? It will automatically deleted the associated subscription.', id: $id, listener: 'deleteForm');
    }

    public function confirmDeleteFormBuilder($id)
    {
        $this->dispatch('swal:confirm', type: 'question', text: 'Are you sure you want to delete this form builder?', id: $id, listener: 'deleteFormBuilder');
    }

    public function deleteForm($id)
    {
        $form = Form::find($id);

        if ($form->subscription()->exists()) {
            $form->subscription()->delete();
        }

        $form->delete();

        $this->dispatch('swal:modal', type: 'success', text: 'Form deleted successfully', title: 'Success!');
    }

    public function deleteFormBuilder($id)
    {
        $form = Form::find($id);

        $form->fields()->delete();

        $this->dispatch('swal:modal', type: 'success', text: 'Form builder deleted successfully', title: 'Success!');
    }
}

app/Livewire/SubscriptionTable.php
<?php

namespace App\Livewire;

use App\Models\Subscription;
use Livewire\Attributes\Url;
use Livewire\Component;
use Livewire\WithPagination;

class SubscriptionTable extends Component
{
    use WithPagination;

    #[Url(history: true)]
    public $perPage = 5;

    #[Url(history: true)]
    public $search = "";

    #[Url(history: true)]
    public $sortBy = "created_at";

    #[Url(history: true)]
    public $sortDir = "desc";

    protected $listeners = ['deleteSubs'];

    public function updatedSearch()
    {
        $this->resetPage();
    }

    public function setSortBy($sortByField)
    {
        if ($this->sortBy == $sortByField) {
            $this->sortDir = ($this->sortDir == "asc") ? "desc" : "asc";
            return;
        }
        $this->sortBy = $sortByField;
        $this->sortDir = "desc";
    }

    public function render()
    {
        $subscriptions = Subscription::with('form')->search($this->search)->orderBy($this->sortBy, $this->sortDir)->paginate($this->perPage);

        return view('livewire.subscription-table', [
            'subscriptions' => $subscriptions,
            'totalResults' => $subscriptions->total(),
            'firstResult' => $subscriptions->firstItem(),
            'lastResult' => $subscriptions->lastItem()
        ]);
    }

    public function confirmDeleteSub($id)
    {
        $this->dispatch('swal:confirm', type: 'question', text: 'Are you sure you want to delete this subscription plan ?', id: $id, listener: 'deleteSubs');
    }

    public function deleteSubs($id)
    {
        $subscription = Subscription::find($id);

        $subscription->delete();

        $this->dispatch('swal:modal', type: 'success', text: 'Subscription deleted successfully', title: 'Success!');
    }
}

app/Livewire/UserTable.php
<?php

namespace App\Livewire;

use App\Models\User;
use Livewire\Attributes\Url;
use Livewire\Component;
use Livewire\WithPagination;

class UserTable extends Component
{
    use WithPagination;

    #[Url(history: true)]
    public $perPage = 5;

    #[Url(history: true)]
    public $search = "";

    #[Url(history: true)]
    public $sortBy = "created_at";

    #[Url(history: true)]
    public $sortDir = "desc";

    public function updatedSearch()
    {
        $this->resetPage();
    }

    public function setSortBy($sortByField)
    {
        if ($this->sortBy == $sortByField) {
            $this->sortDir = ($this->sortDir == "asc") ? "desc" : "asc";
            return;
        }
        $this->sortBy = $sortByField;
        $this->sortDir = "desc";
    }

    public function render()
    {
        $users = User::with('roles')->search($this->search)->orderBy($this->sortBy, $this->sortDir)->paginate($this->perPage);

        return view('livewire.user-table', [
            'users' => $users,
            'totalResults' => $users->total(),
            'firstResult' => $users->firstItem(),
            'lastResult' => $users->lastItem()
        ]);
    }
}

resources/views/livewire/form-table.blade.php
<div>
    <div class="d-flex flex-row justify-content-between mb-3">
        <div class="float-left">
            <div class="d-flex flex-lg-row align-items-center">
                <label class="w-auto">
                    <select class="form-select" wire:model.live='perPage'>
                        <option value="5" selected>
                            5
                        </option>
                        <option value="10">
                            10
                        </option>
                        <option value="25">
                            25
                        </option>
                        <option value="50">
                            50
                        </option>
                        <option value="100">
                            100
                        </option>
                    </select>
                </label>
                <small class="ms-2 text-muted">
                    Records per page
                </small>
            </div>
        </div>
        <div class="float-right">
            <input type="text" wire:model.live.debounce.500ms="search" class="form-control" placeholder="Search..." />
        </div>
    </div>
    <div class="table-responsive">
        <table class="table table-striped table-row-bordered gy-5 gs-7 border rounded">
            <thead>
                <tr class="fw-bold fs-6 text-gray-800 px-7">
                    @include('livewire.includes.table-sortable', ['name' => 'name', 'displayName' => 'Name'])
                    @include('livewire.includes.table-sortable', ['name' => 'description', 'displayName' => 'Description'])
                    @include('livewire.includes.table-sortable', ['name' => 'created_at', 'displayName' => 'Created At'])
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>
                @forelse ($forms as $form)
                    <tr>
                        <td>{{ $form->name }}</td>
                        <td>{{ $form->description }}</td>
                        <td>{{ \Carbon\Carbon::parse($form->created_at)->format('j M Y') }}</td>
                        <td>
                            <div class="btn-group">
                                <a href="{{ route('form.edit', $form) }}" class='btn btn-icon btn-success btn-sm'><i class="fas fa-pencil"></i></a>
                                <button type="button" class='btn btn-icon btn-danger btn-sm' wire:click="confirmDeleteForm({{ $form->id }})"><i class="fas fa-trash"></i></button>
                                @if($form->fields()->exists())
                                <button type="button" class='btn btn-dark btn-sm' wire:click="confirmDeleteFormBuilder({{ $form->id }})">Delete Form Builder</button>
                                @else
                                <a href="{{ route('form.builder', $form) }}" class='btn btn-info btn-sm'>Form Builder</a>
                                @endif
                            </div>
                        </td>
                    </tr>
                @empty
                    <tr>
                        <td class="text-center" colspan="6">No Data Available</td>
                    </tr>
                @endforelse
            </tbody>
        </table>
    </div>
    <div class="d-flex flex-row justify-content-between mb-3">
        <div class="float-left">
            <span class="text-gray-500">Showing {{ $firstResult }} to {{ $lastResult }} of {{ $totalResults }} results</span>
        </div>
        <div class="float-right">
            {{ $forms->links() }}
            <div class="text-muted">
            </div>
        </div>
    </div>
</div>

resources/views/livewire/subscription-table.blade.php
<div>
    <div class="d-flex flex-row justify-content-between mb-3">
        <div class="float-left">
            <div class="d-flex flex-lg-row align-items-center">
                <label class="w-auto">
                    <select class="form-select" wire:model.live='perPage'>
                        <option value="5" selected>
                            5
                        </option>
                        <option value="10">
                            10
                        </option>
                        <option value="25">
                            25
                        </option>
                        <option value="50">
                            50
                        </option>
                        <option value="100">
                            100
                        </option>
                    </select>
                </label>
                <small class="ms-2 text-muted">
                    Records per page
                </small>
            </div>
        </div>
        <div class="float-right">
            <input type="text" wire:model.live.debounce.500ms="search" class="form-control" placeholder="Search..." />
        </div>
    </div>
    <div class="table-responsive">
        <table class="table table-striped table-row-bordered gy-5 gs-7 border rounded">
            <thead>
                <tr class="fw-bold fs-6 text-gray-800 px-7">
                    @include('livewire.includes.table-sortable', ['name' => 'name', 'displayName' => 'Name'])
                    @include('livewire.includes.table-sortable', ['name' => 'description', 'displayName' => 'Description'])
                    @include('livewire.includes.table-sortable', ['name' => 'price', 'displayName' => 'Price'])
                    <th>Form Name</th>
                    @include('livewire.includes.table-sortable', ['name' => 'created_at', 'displayName' => 'Date Joined'])
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>
                @forelse ($subscriptions as $subscription)
                    <tr>
                        <td>{{ $subscription->name }}</td>
                        <td>{{ $subscription->description }}</td>
                        <td>{{ $subscription->price }}</td>
                        <td>{{ $subscription->form->name }}</td>
                        <td>{{ \Carbon\Carbon::parse($subscription->created_at)->format('j M Y') }}</td>
                        <td>
                            <div class="btn-group">
                                <a href="{{ route('subscription.edit', $subscription) }}" class='btn btn-icon btn-success btn-sm'><i class="fas fa-pencil"></i></a>
                                <button type="button" class='btn btn-icon btn-danger btn-sm' wire:click="confirmDeleteSub({{ $subscription->id }})"><i class="fas fa-trash"></i></button>
                            </div>
                        </td>
                    </tr>
                @empty
                    <tr>
                        <td class="text-center" colspan="6">No Data Available</td>
                    </tr>
                @endforelse
            </tbody>
        </table>
    </div>
    <div class="d-flex flex-row justify-content-between mb-3">
        <div class="float-left">
            <span class="text-gray-500">Showing {{ $firstResult }} to {{ $lastResult }} of {{ $totalResults }} results</span>
        </div>
        <div class="float-right">
            {{ $subscriptions->links() }}
            <div class="text-muted">
            </div>
        </div>
    </div>
</div>

resources/views/livewire/user-table.blade.php
<div>
    <div class="d-flex flex-row justify-content-between mb-3">
        <div class="float-left">
            <div class="d-flex flex-lg-row align-items-center">
                <label class="w-auto">
                    <select class="form-select" wire:model.live='perPage'>
                        <option value="5" selected>
                            5
                        </option>
                        <option value="10">
                            10
                        </option>
                        <option value="25">
                            25
                        </option>
                        <option value="50">
                            50
                        </option>
                        <option value="100">
                            100
                        </option>
                    </select>
                </label>
                <small class="ms-2 text-muted">
                    Records per page
                </small>
            </div>
        </div>
        <div class="float-right">
            <input type="text" wire:model.live.debounce.500ms="search" class="form-control" placeholder="Search..." />
        </div>
    </div>
    <div class="table-responsive">
        <table class="table table-striped table-row-bordered gy-5 gs-7 border rounded">
            <thead>
                <tr class="fw-bold fs-6 text-gray-800 px-7">
                    @include('livewire.includes.table-sortable', ['name' => 'name', 'displayName' => 'Name'])
                    @include('livewire.includes.table-sortable', ['name' => 'email', 'displayName' => 'Email'])
                    <th>Roles</th>
                    @include('livewire.includes.table-sortable', ['name' => 'created_at', 'displayName' => 'Date Joined'])
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>
                @forelse ($users as $user)
                    <tr>
                        <td>{{ $user->name }}</td>
                        <td>{{ $user->email }}</td>
                        <td>{{ $user->roles->implode('name', ', ') }}</td>
                        <td>{{ \Carbon\Carbon::parse($user->created_at)->format('j M Y') }}</td>
                        <td>
                            <div class="btn-group">
                                <a href="{{ route('user.edit', $user) }}" class='btn btn-icon btn-success btn-sm'><i class="fas fa-pencil"></i></a>
                            </div>
                        </td>
                    </tr>
                @empty
                    <tr>
                        <td class="text-center" colspan="6">No Data Available</td>
                    </tr>
                @endforelse
            </tbody>
        </table>
    </div>
    <div class="d-flex flex-row justify-content-between mb-3">
        <div class="float-left">
            <span class="text-gray-500">Showing {{ $firstResult }} to {{ $lastResult }} of {{ $totalResults }} results</span>
        </div>
        <div class="float-right">
            {{ $users->links() }}
            <div class="text-muted">
            </div>
        </div>
    </div>
</div>